/* 		
*  		 				   |================|
*				      		   |/\/\/\/\/\/\/\/\|
*  		      				   < Knife | Runner >
*                     				   |\/\/\/\/\/\/\/\/|
*		      		      	 	   |================|
*
*  				          [Credits]
*						 Grim: Idea's & Helping.
*						 Stenudd: Testing
*						 Emp`: Fixing & Testing
*
* 					  [v1.0]
*   					         -Release
*/

#include <amxmodx>
#include <amxmisc>
#include <hamsandwich>
#include <fakemeta>

#define PLUGIN "Knife | Runner"
#define VERSION "1.0"
#define AUTHOR "Xalus"

#define TAG "Kr"

new Runner[33];
new Kr_status, Kr_frags, Kr_damage, Kr_delay, Kr_msgDeathMsg;

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	/* Ham */
	RegisterHam( Ham_TakeDamage, "player", "FwdHamPlayerDamage" );
	RegisterHam( Ham_Spawn, "player", "FwdHamPlayerSpawn", 1 );
	
	/* Other */
	Kr_msgDeathMsg = get_user_msgid("DeathMsg");

	/* Death Message */
	register_message(Kr_msgDeathMsg, "FwdDeathMsg");

	/* Cvar */
	Kr_status	= register_cvar("kr_status"		, "1");
	Kr_frags	= register_cvar("kr_frags"		, "1");
	Kr_damage	= register_cvar("kr_damage"		, "10");
	Kr_delay	= register_cvar("kr_delay"		, "5.0");
}
public FwdHamPlayerSpawn(id)
	if(is_user_connected(id))
		ResetAttacker(id)

public FwdHamPlayerDamage(id, weapon, attacker, Float:damage, damagebits)
	if(get_pcvar_num(Kr_status) && is_user_connected(attacker) && get_pcvar_float(Kr_damage) <= damage
	&& get_user_weapon(id) == CSW_KNIFE)
	{
		Runner[id] = attacker
		if(get_pcvar_num(Kr_delay))
			set_task(get_pcvar_float(Kr_delay), "ResetAttacker", id)
				
		new AttackerName[32]
		get_user_name(Runner[id], AttackerName, 31)
	}
		
public FwdDeathMsg()
{
	new iAttacker = get_msg_arg_int(1);
	new id = get_msg_arg_int(2);

	new szClassname[ 32 ];
	pev( iAttacker, pev_classname, szClassname, charsmax( szClassname ) );
	
	if( get_pcvar_num(Kr_status) && Runner[id] != 0 && is_user_connected(Runner[id])
	&& equal( szClassname, "worldspawn" ))
	{
		// Get Runner name
		new RunnerName[32]
		get_user_name(id, RunnerName, 31)
		// Make Deathmsg
		make_deathmsg(Runner[id], id, 0, "worldspawn")
		// Print if Kr detected a runner.
		ChatColor(0, "!g|%s|!y Runner Detected. (!team%s!y)", TAG, RunnerName)
		// Give Attacker of runner a frag
		new KrFragCount = get_user_frags(Runner[id]) + get_pcvar_num(Kr_frags)
		set_pev(Runner[id], pev_frags, float(KrFragCount))
		// Block the DeathMsg
		return PLUGIN_HANDLED;
	}
		
	return PLUGIN_CONTINUE;
}
public ResetAttacker(id)
	if(is_user_connected(id))
		Runner[id] = 0
		
stock ChatColor(const id, const input[], any:...)
{
	new count = 1, players[32]
	static msg[191]
	vformat(msg, 190, input, 3)
    
	replace_all(msg, 190, "!g", "^4") // Green Color
	replace_all(msg, 190, "!y", "^1") // Default Color
	replace_all(msg, 190, "!team", "^3") // Team Color
	//replace_all(msg, 190, "!t", "^0") // Team2 Color
    
	if (id) players[0] = id; else get_players(players, count, "ch")
	{
		for (new i = 0; i < count; i++)
		{
			message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
			write_byte(players[i]);
			write_string(msg);
			message_end();
		}
	}
}
